#include <assert.h>
#include <stdio.h>
#include "gsl/gsl_linalg.h"

int main()
{
	int r, j, i;
	/*
	double a_data[] = {
		1, 0, 0, 0, 2,
		0, 0, 3, 0, 0,
		0, 0, 0, 0, 0,
		0, 4, 0, 0, 0};
	*/

	gsl_matrix *a = gsl_matrix_calloc(5, 4);
	gsl_matrix_set(a, 0, 0, 1.0);
	gsl_matrix_set(a, 4, 0, 2.0);
	gsl_matrix_set(a, 2, 1, 3.0);
	gsl_matrix_set(a, 1, 3, 4.0);

	gsl_matrix *v = gsl_matrix_alloc(4,4);
	gsl_vector *s = gsl_vector_alloc(4);
	gsl_vector *w = gsl_vector_alloc(4);

	r = gsl_linalg_SV_decomp(a, v, s, w);

	for (i = 0; i < 5; i++)
		for (j = 0; j < 4; j++)
			printf("a[%d][%d] = %g\n", i, j,
					gsl_matrix_get(a, i, j));

	gsl_matrix_free(a);
	gsl_matrix_free(v);
	gsl_vector_free(s);
	gsl_vector_free(w);

	return r;
}
